package com.terraformersmc.terraform.block;


import java.util.Iterator;
import java.util.Random;

import net.minecraft.block.*;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1922;
import net.minecraft.class_1928;
import net.minecraft.class_1937;
import net.minecraft.class_2195;
import net.minecraft.class_2248;
import net.minecraft.class_2302;
import net.minecraft.class_2338;
import net.minecraft.class_2344;
import net.minecraft.class_2513;
import net.minecraft.class_2680;
import net.minecraft.class_3486;
import net.minecraft.class_4538;
import org.spongepowered.asm.mixin.Overwrite;

/**
 * A custom farmland block for new farmland. Mixins are required to make hoes create these blocks and to allow seeds to be planted.
 * */
public class TerraformFarmlandBlock extends class_2344 {
	private static class_2248 trampled; //sets the block to revert to when trampled

	public TerraformFarmlandBlock(class_2251 settings, class_2248 trampled) {
		super(settings);
		this.method_9590(this.method_9595().method_11664().method_11657(field_11009, 0));
		this.trampled = trampled;
	}

	public class_2680 method_9605(class_1750 context) {
		return !this.method_9564().method_11591(context.method_8045(), context.method_8037()) ? trampled.method_9564() : this.method_9564();
	}

	public void onScheduledTick(class_2680 state, class_1937 world, class_2338 pos, Random rand) {
		if (!state.method_11591(world, pos)) {
			setToCustomDirt(state, world, pos);
		} else {
			int moisture = state.method_11654(field_11009);
			if (!isWaterNearby(world, pos) && !world.method_8520(pos.method_10084())) {
				if (moisture > 0) {
					world.method_8652(pos, state.method_11657(field_11009, moisture - 1), 2);
				} else if (!hasCrop(world, pos)) {
					setToCustomDirt(state, world, pos);
				}
			} else if (moisture < 7) {
				world.method_8652(pos, state.method_11657(field_11009, 7), 2);
			}

		}
	}

	public static void setToCustomDirt(class_2680 state, class_1937 world, class_2338 pos) {
		world.method_8501(pos, method_9582(state, trampled.method_9564(), world, pos));
	}

	private static boolean hasCrop(class_1922 view, class_2338 pos) {
		class_2248 block = view.method_8320(pos.method_10084()).method_11614();
		return block instanceof class_2302 || block instanceof class_2513 || block instanceof class_2195;
	}

	@Override
	public void method_9554(class_1937 world, class_2338 pos, class_1297 entity, float height) {
		if (!world.field_9236 && world.field_9229.nextFloat() < height - 0.5F && entity instanceof class_1309 && (entity instanceof class_1657 || world.method_8450().method_8355(class_1928.field_19388)) && entity.method_17681() * entity.method_17681() * entity.method_17682() > 0.512F) {
			this.setToCustomDirt(world.method_8320(pos), world, pos);
		}

		entity.method_5747(height, 1.0F);
	}

	private static boolean isWaterNearby(class_4538 world, class_2338 pos) {
		Iterator iterator = class_2338.method_10097(pos.method_10069(-4, 0, -4), pos.method_10069(4, 1, 4)).iterator();

		class_2338 checkPos;
		do {
			if (!iterator.hasNext()) {
				return false;
			}

			checkPos = (class_2338)iterator.next();
		} while(!world.method_8316(checkPos).method_15767(class_3486.field_15517));

		return true;
	}
}
