package com.terraformersmc.terraform.feature;

import com.mojang.datafixers.Dynamic;
import java.util.Random;
import java.util.Set;
import java.util.function.Function;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2410;
import net.minecraft.class_2680;
import net.minecraft.class_2944;
import net.minecraft.class_3341;
import net.minecraft.class_3747;

public class FallenLogFeature extends class_2944<FallenLogFeatureConfig> {
    public FallenLogFeature(Function<Dynamic<?>, ? extends FallenLogFeatureConfig> function) {
        super(function);
    }

    @Override
    public boolean generate(class_3747 world, Random rand, class_2338 origin, Set<class_2338> logs, Set<class_2338> leaves, class_3341 box, FallenLogFeatureConfig config) {
        // Total log length
        int length = rand.nextInt(config.lengthRandom) + config.field_21291;

        // Axis
        class_2350.class_2351 axis = rand.nextBoolean() ? class_2350.class_2351.field_11048 : class_2350.class_2351.field_11051;
        class_2350 direction = class_2350.method_10169(axis, rand.nextBoolean() ? class_2350.class_2352.field_11056 : class_2350.class_2352.field_11060);

        class_2338 below = origin.method_10074();
        if (!method_16430(world, below)) {
            return false;
        }

        class_2338.class_2339 pos = new class_2338.class_2339(origin);

        int air = 0;
        for (int i = 0; i < length; i++) {
            pos.method_10098(direction);

            if (!world.method_16358(pos.method_10098(class_2350.field_11033), class_2680::method_11619)) {
                air++;
            }

            if (!method_16420(world, pos.method_10098(class_2350.field_11036))) {
                return false;
            }
        }

        // No floating logs
        if (air * 2 > length) {
            return false;
        }

        pos.method_10101(origin);
        for (int i = 0; i < length; i++) {
            pos.method_10098(direction);

            class_2680 log = config.field_21288.method_23455(rand, pos);

			if (method_16420(world, pos) || method_16425(world, pos) || method_16422(world, pos)) {
				this.method_12773(world, pos, log.method_11657(class_2410.field_11459, axis), box);
				logs.add(pos.method_10062());
			}

            pos.method_10098(class_2350.field_11033);

            if (method_16430(world, pos)) {
            	method_16427(world, pos);
            }

            pos.method_10098(class_2350.field_11036);
        }

        return true;
    }
}
