package com.terraformersmc.terraform.feature;

import com.google.common.collect.ImmutableMap;
import com.google.common.collect.Lists;
import com.mojang.datafixers.Dynamic;
import com.mojang.datafixers.types.DynamicOps;
import java.util.List;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import net.minecraft.class_4643;
import net.minecraft.class_4651;
import net.minecraft.class_4652;
import net.minecraft.class_4662;

public class FallenLogFeatureConfig extends class_4643 {
	public final int lengthRandom;

	protected FallenLogFeatureConfig(class_4651 trunk, class_4651 leaves, List<class_4662> decorators, int baseLength, int lengthRandom) {
		super(trunk, leaves, decorators, baseLength);

		this.lengthRandom = lengthRandom;
	}

	public <T> Dynamic<T> method_16587(DynamicOps<T> ops) {
		ImmutableMap.Builder<T, T> builder = ImmutableMap.builder();

		builder
			.put(ops.createString("trunk_provider"), this.field_21288.method_19508(ops))
			.put(ops.createString("leaves_provider"), this.field_21289.method_19508(ops))
			.put(ops.createString("decorators"), ops.createList(this.field_21290.stream().map(treeDecorator -> treeDecorator.method_19508(ops))))
			.put(ops.createString("base_length"), ops.createInt(this.field_21291))
			.put(ops.createString("length_random"), ops.createInt(this.lengthRandom));

		return new Dynamic<>(ops, ops.createMap(builder.build()));
	}

	public static <T> FallenLogFeatureConfig deserialize(Dynamic<T> dynamic) {
		class_4652<?> trunk = class_2378.field_21445.method_10223(new class_2960(dynamic.get("trunk_provider").get("type").asString().orElseThrow(RuntimeException::new)));
		class_4652<?> leaves = class_2378.field_21445.method_10223(new class_2960(dynamic.get("leaves_provider").get("type").asString().orElseThrow(RuntimeException::new)));

		return new FallenLogFeatureConfig(
			trunk.method_23456(dynamic.get("trunk_provider").orElseEmptyMap()),
			leaves.method_23456(dynamic.get("leaves_provider").orElseEmptyMap()),
			dynamic.get("decorators").asList(
				dynamicx -> class_2378.field_21448.method_10223(
					new class_2960(dynamicx.get("type").asString().orElseThrow(RuntimeException::new))
				).method_23472(dynamicx)
			),
			dynamic.get("base_length").asInt(0),
			dynamic.get("length_random").asInt(0)
		);
	}

	public static class Builder extends class_4643.class_4644 {
		private List<class_4662> decorators = Lists.newArrayList();
		private int baseLength;
		private int lengthRandom;

		public Builder(class_4651 trunk, class_4651 leaves) {
			super(trunk, leaves);
		}

		public Builder baseLength(int length) {
			this.baseLength = length;
			return this;
		}

		public Builder lengthRandom(int variance) {
			this.lengthRandom = variance;
			return this;
		}

		public FallenLogFeatureConfig build() {
			return new FallenLogFeatureConfig(this.field_21292, this.field_21293, this.decorators, this.baseLength, this.lengthRandom);
		}
	}
}
