package com.terraformersmc.terraform.surface;

import com.mojang.datafixers.Dynamic;
import java.util.Random;
import java.util.function.Function;
import net.minecraft.class_1959;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_2791;
import net.minecraft.class_3523;
import net.minecraft.class_3527;

public class CliffSurfaceBuilder extends class_3523<CliffSurfaceConfig> {
	private int seaLevel;
	private class_3523<class_3527> parent;

	public CliffSurfaceBuilder(Function<Dynamic<?>, ? extends CliffSurfaceConfig> function, int seaLevel, class_3523<class_3527> parent) {
		super(function);

		this.seaLevel = seaLevel;
		this.parent = parent;
	}

	@Override
	public void generate(Random rand, class_2791 chunk, class_1959 biome, int x, int z, int height, double noise, class_2680 stone, class_2680 water, int var11, long seed, CliffSurfaceConfig config) {
		x &= 15;
		z &= 15;

		height -= 1;

		if (noise > 0.5D && height > seaLevel + 1 && height < seaLevel + 12) {
			if (height > seaLevel + 5) {
				height = seaLevel + 5;
			}

			class_2338.class_2339 pos = new class_2338.class_2339(x, height, z);

			int basaltLayers = 3;

			if (noise > 1.0D) {
				basaltLayers += 1;
			}

			if (noise > 1.5D) {
				basaltLayers += 1;
			}

			if (height >= seaLevel + 7) {
				basaltLayers += (seaLevel + 5 - height) / 2;
			}

			for (int i = 0; i < basaltLayers; i++) {
				chunk.method_12010(pos, config.getCliffMaterial(), false);
				pos.method_10098(class_2350.field_11036);
			}

			for (int i = 0; i < 3; i++) {
				chunk.method_12010(pos, config.method_15336(), false);
				pos.method_10098(class_2350.field_11036);
			}

			chunk.method_12010(pos, config.method_15337(), false);
		} else {
			parent.method_15305(rand, chunk, biome, x, z, height, noise, stone, water, var11, seed, config);
		}
	}
}
